var fs = require('fs')
var gulp = require('gulp')
var log = require('gulp-util').log
var babelify = require('babelify')
var browserify = require('browserify')

var ex = {}

ex.log = function (what, colorCode) {
    return ('\u001b[' + colorCode + 'm' + what + '\u001b[0m')
}

ex.generateBundle = function (input, output) {
  log("Running '" + ex.log("babelify", 36) + "'")
  browserify({ debug: true })
    .transform(babelify)
    .require(input, { entry: true })
    //.plugin('minifyify', { map: 'static/bundle.js.map', output: output + '.map' })
    .plugin('prependify', '/**\n  This file was autogenerated.\n'
      + '  See https://github.com/borgbackup/borgweb\n'
      + '*/\n')
    .bundle() // todo: Why double sourcemap? https://github.com/ben-ng/minifyify/issues/95#issuecomment-117227925
    .on('error', function (err) { log("Error: " + err.message) })
    .pipe(fs.createWriteStream(output))
}

module.exports = ex
